package ru.volgait.task12;

import sun.reflect.generics.reflectiveObjects.NotImplementedException;

import java.util.List;

/**
 * Created by Mikhail Tarapata on 29.04.2017.
 */
public class BinaryTreeUtils {
    // глубина дерева
    public static int depth(Node<?> tree) {
        int result;
        if (tree != null) {
            int leftDepth = depth(tree.left);
            int rightDepth = depth(tree.right);
            result = Math.max(leftDepth, rightDepth) + 1;
        } else {
            result = 0;
        }

        return result;
    }

    // содержится ли значение value в дереве
    public static <T> boolean contains(Node<T> tree, T value) {
        boolean result;
        if (tree == null) {
            result = false;
        } else {
            result = tree.value.equals(value) || contains(tree.right, value) || contains(tree.left, value);
        }
        return result;
    }

    // узел дерева содержащий значение value или null, если значение не найдено
    public static <T> Node<T> node(Node<T> tree, T value) {
        Node<T> result = null;
        if (tree != null) {
            if (tree.value.equals(value)) {
                result = tree;
            } else {
                result = node(tree.left, value);
                if (result == null) {
                    result = node(tree.right, value);
                }
            }
        }
        return result;
    }

    // путь от корня до узла дерева, который содержит значение value или пустой список, если в дереве нет такого значения
    public static <T> List<T> path(Tree<T> tree, T value) {
        throw new NotImplementedException();
    }

    public static void prettyPrint(Node<?> tree) {
        throw new NotImplementedException();
    }

    public static <T> Node<T> clone(Node<T> tree) {
        Node<T> left = null;
        Node<T> right = null;
        if (tree.left != null) {
            left = clone(tree.left);
        }
        if (tree.right != null) {
            right = clone(tree.right);
        }
        Node<T> newRoot = new Node<T>();
        newRoot.left = left;
        newRoot.right = right;
        newRoot.value = tree.value;
        return newRoot;
    }
}
