package ru.volgait.task3;

import java.io.*;

/**
 * Created by Mikhail Tarapata on 29.04.2017.
 */
public class CompressorImpl implements Compressor {
    @Override
    public void compress(InputStream input, OutputStream output) throws IOException {
        if(input == null || output == null) {
            throw new IllegalArgumentException();
        }

        try (Reader reader = new InputStreamReader(input, "UTF-8")) {
            int code;
            Integer count = 0;
            Character lastChar = null;
            if( (code = reader.read()) != -1 ) {
                lastChar = (char) code;
                count++;
            }
            while( (code = reader.read()) != -1) {
                char ch = (char) code;
                if(lastChar != null && lastChar.equals(ch)) {
                    count++;
                } else {
                    output.write(count.toString().getBytes());
                    output.write(lastChar);
                    lastChar = (char) code;
                    count = 1;
                }
            }
            output.write(count.toString().getBytes());
            output.write(lastChar);
        }
    }
}
